import { OutputHandler } from "./output";
import { Provider } from "./provider";
export declare type Handler = <T>(node: T) => string | Promise<string>;
export interface FieldRequirement {
    mandatory?: boolean;
    requirement?: (field: any) => boolean;
    explanation?: (field: any) => string;
}
export declare class DocumentProcessor {
    private provider;
    private output;
    private targets;
    private handlers;
    private errors;
    constructor(provider?: Provider, output?: OutputHandler);
    start(): Promise<void>;
    protected addObserver(target: string, handler: Handler, options?: FieldRequirement): void;
    protected field<T>(id: string): T;
    protected addError(error: FieldError): void;
    protected create(): void;
    protected finish(): Promise<void>;
    private testFieldRequirement;
}
export declare class FieldError {
    message: string;
    constructor(message: string);
}
