"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function DocumentObserver(Base) {
    return class extends Base {
        static _addDocumentProcessorObserver(target, handler, requirement) {
            if (!this.hasOwnProperty("observers")) {
                this.observers = [];
            }
            this.observers.push({ target, handler, requirement });
        }
        create() {
            super.create();
            const constructor = this.constructor;
            if (!constructor.hasOwnProperty("observers")) {
                constructor.observers = [];
            }
            constructor.observers.forEach(({ target, handler, requirement }) => this.addObserver(target, handler.bind(this), requirement));
        }
    };
}
exports.DocumentObserver = DocumentObserver;
