export interface OutputHandler {
    append(content: string): void;
    flush(): Promise<void>;
}
export declare class DefaultOutputHandler implements OutputHandler {
    protected document: string;
    append(content: string): void;
    flush(): Promise<void>;
}
export declare class FileOutputHandler extends DefaultOutputHandler {
    private filePath;
    constructor(filePath: string);
    flush(): Promise<void>;
}
export declare class ContentOutputHandler implements OutputHandler {
    content: string;
    protected document: string;
    append(content: string): void;
    flush(): Promise<void>;
}
